﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Text;

namespace Pcb
{
    class Data
    {

    }
    class Device : PanelItem
    {
        CBitmap circuit;
        CBitmap board;
        string description;
        List<CPoint> connections;
        Data data;
        DrawMode drawing;
        public Device()
        {
            DrawMode = DrawMode.Circuit;
            circuit = new CBitmap();
            board = new CBitmap();
            description = "";
            connections = new List<CPoint>();
        }
        public Device(CBitmap circuit, CBitmap board, string description, Data data, CPoint[] connections)
        {
            DrawMode = DrawMode.Circuit;
            this.circuit = circuit;
            this.board = board;
            this.connections = new List<CPoint>();
            this.connections.AddRange(connections);
            this.description = description;
            this.data = data;
        }

        public Device(string path)
        {
            DrawMode = DrawMode.Circuit;
        }
        public void Click()
        {
            Circuit.Click();
        }
        public void SaveDevice(string path)
        {

        }

        public override void Draw(Graphics g, float zoom, VirtualScreen vs)
        {
            if (drawing == DrawMode.Circuit)
                circuit.Draw(g, zoom, vs);
            if (drawing == DrawMode.Board)
                board.Draw(g, zoom, vs);
        }

        public CBitmap Circuit
        {
            get
            {
                return circuit;
            }
            set
            {
                circuit = value;
            }
        }
        public CBitmap Board
        {
            get
            {
                return board;
            }
            set
            {
                board = value;
            }
        }
        public DrawMode DrawMode
        {
            get
            {
                return drawing;
            }
            set
            {
                drawing = value;
            }
        }
    }

    enum DrawMode
    {
        Board = 0, Circuit = 1
    }
}
