﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Drawing;

namespace Pcb
{
    public class InputBox
    {
        Form f;
        TextBox tb;
        public InputBox(string text, string Def)
        {
            //Form
            f = new Form();
            f.Text = text;
            f.FormBorderStyle = FormBorderStyle.FixedToolWindow;
            //Buttons
            Button ok = new Button();
            ok.DialogResult = DialogResult.OK;
            ok.Text = "OK";
            Button abort = new Button();
            abort.DialogResult = DialogResult.Cancel;
            abort.Text = "Abbrechen";
            //Buttonlocation
            ok.Location = new Point(10, 40);
            abort.Location = new Point(120, 40);
            //TextBox
            tb = new TextBox();
            tb.Text = Def.ToString();
            tb.Width = 110 + abort.Width;
            tb.Location = new Point(10, 10);
            f.Controls.Add(tb);
            //Form
            f.Size = new Size(130 + abort.Width, 70 + abort.Height);
            f.Controls.Add(ok);
            f.Controls.Add(abort);
        }
        public static string StringInputBox(string Def, string text)
        {
            InputBox ib = new InputBox(text, Def);
            if (ib.f.ShowDialog() == DialogResult.Abort)
                return Def;
            return ib.tb.Text;
        }
        public static int NumericInputBox(int Def, string text)
        {
            InputBox ib = new InputBox(text, Def.ToString());
            ib.tb.Tag = Def.ToString();
            ib.tb.TextChanged += new EventHandler(tb_TextChanged);
            if(ib.f.ShowDialog() != DialogResult.OK)
                return Def;
            if (ib.tb.Text == "")
                return Def;
            return Convert.ToInt32(ib.tb.Text);
        }

        static void tb_TextChanged(object sender, EventArgs e)
        {
            if (((TextBox)sender).Text == "")
                return;
            try
            {
                Convert.ToInt32(((TextBox)sender).Text);
                ((TextBox)sender).Tag = ((TextBox)sender).Text;
            }
            catch(Exception)
            {
                ((TextBox)sender).Text = (string)((TextBox)sender).Tag;
            }
        }
    }
}
