﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Drawing;

namespace Pcb
{
    class Pcb
    {
        int actualDrawing = -1; //Beschreibt was gerade gezeichnet wird (^= DrawingMode)
        int raster = 10;        //Das Raster des Panels
        Modus mode = Modus.Plan;//Startmodus: Nach dem Programmstart kann man einen Schaltplan erstellen
        ExPanelHelper panel1;     //DoubleBuffer Panel
        int tool;
        public Pcb(Form f)
        {
            mode = Modus.Bauteil;
            tool = -1;
            //Doublebuffer Panel erstellen
            panel1 = new ExPanelHelper(f);
            panel1.Dock = DockStyle.Fill;
            panel1.VirtualScreen.Location = new CPoint(-panel1.Width / 2, -panel1.Height / 2); ;
            panel1.Paint += new PaintEventHandler(panel1_Paint);
            panel1.MouseDown += new MouseEventHandler(panel1_MouseDown);
            panel1.MouseUp += new MouseEventHandler(panel1_MouseUp);
            panel1.MouseMove += new MouseEventHandler(panel1_MouseMove);
            f.Controls.Add(panel1);
        }
        public void Clear()
        {
            panel1.Items.Clear();
        }
        public void SetMode(Modus m)
        {
            Clear();
            mode = m;
            if(mode == Modus.Bauteil)
                panel1.Items.Add(new Device());
        }
        public void SetTool(int tool)
        {
            this.tool = tool;
        }

        public ExPanelHelper Panel
        {
            get
            {
                return panel1;
            }
        }
        public int Raster
        {
            get
            {
                return raster;
            }
            set
            {
                raster = value;
            }
        }
        #region Panel1
        private void panel1_Paint(object sender, PaintEventArgs e)
        {
            
        }
        private void panel1_MouseDown(object sender, MouseEventArgs e)
        {

            CPoint Loc = Methods.ToRaster(panel1.VirtualScreen.FromScreen(e.Location), raster * panel1.Zoom) / panel1.Zoom;
            if (mode == Modus.Bauteil)
            {
                if (tool != -1)
                {
                    actualDrawing = ((Device)panel1.Items[0]).Circuit.AddDraw(new CDrawing((DrawingMode)tool, 0, Loc, Loc, Color.Black));
                }
            }
        }
        private void panel1_MouseUp(object sender, MouseEventArgs e)
        {
            actualDrawing = -1;
        }
        private void panel1_MouseMove(object sender, MouseEventArgs e)
        {
            //Mouseposition in Raster umrechnen
            CPoint p1 = panel1.VirtualScreen.FromScreen(e.Location);
            CPoint Loc = Methods.ToRaster(p1, raster * panel1.Zoom) / panel1.Zoom;
            if (mode == Modus.Bauteil)
            {
                if (actualDrawing != -1) //Nur wenn etwas gerade gezeichnet wird
                {
                    if (e.Button == MouseButtons.Left)
                        ((Device)panel1.Items[0]).Circuit[actualDrawing].P2 = Loc;
                    panel1.Refresh();
                }
            }
        }
        #endregion
    }

    enum Modus
    {
        Plan, Bauteil
    }
}
