﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Pcb
{
    class VirtualScreen
    {
        CPoint p;
        public VirtualScreen()
        {
            p = new CPoint(0,0);
        }
        /// <summary>
        /// Punkt an dem sich der ViruelleScreen sich befindet.
        /// </summary>
        public CPoint Location
        {
            get
            {
                return p;
            }
            set
            {
                p = value;
            }
        }
        /// <summary>
        /// Gibt den umgerechneten Punkt zum Zeichnen zurück
        /// </summary>
        /// <param name="point">Der Punkt zum Umrechnen</param>
        /// <returns>Umgerechneter Punkt</returns>
        public CPoint ToScreen(CPoint point)
        {
            return point - p;
        }
        /// <summary>
        /// Berechnet wie ToScreen() den Punkt zum Zeichnen. Gibt null zurück
        /// falls der Wert außerhalb der Zeichenfläche liegen sollte.
        /// </summary>
        /// <param name="point">Der Punkt zum Umrechnen</param>
        /// <param name="Size">Die Größe der Zeichenfläche</param>
        /// <returns>Umgerechneter Punkt oder null</returns>
        public CPoint ToScreenEx(CPoint point, CPoint Size)
        {
            CPoint temp = ToScreen(point);
            if (IsInScreen(temp, Size))
                return temp;
            return null;
        }
        /// <summary>
        /// Prüft ob ein Punkt im gesehenen Bild ist
        /// </summary>
        /// <param name="point">Der zu prüfende Punkt</param>
        /// <param name="Size">Größe der Zeichenfläche</param>
        /// <returns></returns>
        public bool IsInScreen(CPoint point, CPoint Size)
        {
            return point >= 0 && point <= Size;
        }
        /// <summary>
        /// Rechnet die Position vom VS zurück auf die "Map"
        /// </summary>
        /// <param name="point">Punkt zum rechnen (z.b. Mouseposition)</param>
        /// <returns></returns>
        public CPoint FromScreen(CPoint point)
        {
            return point + p;
        }
    }
}
